Page MenuHomePhabricator

Tool for displaying a user contribution summary
Open, Needs TriagePublic

Description

NOTE: Details of this task are tracked in the WikiCV project.

The open-source movement has shown that being able to showcase your contributions as a proof of your skill and/or dedication is a powerful motivation for participating. A similar incentive for Wikipedia would be a powerful force to draw new editors to the project and allow existing editors to spend more time on it without harming their career; unfortunately, due to the highly collaborative nature of Wikipedia, the value of one's participation is hard to measure for an outsider, which makes it very hard for contributors to take credit for value added to Wikipedia.

This is a hard problem that needs to be tackled gradually over time. A good first step would be the creation of a contribution summarizing tool which (unlike the existing ones that focus on statistics and are hard to interpret for someone not familiar with Wikipedia editing) highlights contributions in an easy-to-understand manner. To do that,

  • come up with a set of achievements which are programmatically measurable and easy to interpret (e.g. user is the primary author of an article that has been featured, or has gotten a high number of views; has created N high-quality articles over some period of time; has started N important articles in a given topic; is in the top 1% of users by editcount)
  • write a Toolforge tool for measuring them for a given user
  • add a cache layer as the previous step will probably be expensive
  • write a nice frontend for displaying them (probably some kind of contribution timeline; see e.g. Github contributor activity or Stackoverflow developer stories)
  • write an API so that other tools can fetch and use the data
  • maybe provide some sort of opt-in for making it public (OAuth, or freeride on the opt-in methods other edit counters use) to avoid people being negatively affected by how information is presented about them
  • bonus: provide an UI for the user to customize the information presented about them (e.g. select which articles to showcase)

See also

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
Tgr updated the task description. (Show Details)Oct 6 2017, 9:24 AM
Tgr updated the task description. (Show Details)Oct 6 2017, 9:36 AM
Tgr updated the task description. (Show Details)Oct 6 2017, 10:47 AM

@Meghasharma213 thanks! Please don't forget to also fill out the eligibility section of tht Outreachy application form. If you have time, please work on one of the coding-related microtasks as well.

@Sagorika1996, thanks! I left some comments on the pull requests.

@Yashasingh, thanks! Please don't forget to fill out the eligibility section of tht Outreachy application form.

@Ksuthagar23, welcome!

@Mvolz, WikiProject edit counters has a list of all kinds of counters if you are interested.

Tgr updated the task description. (Show Details)Oct 6 2017, 10:49 AM
Alisainy removed a subscriber: Alisainy.Oct 6 2017, 4:47 PM

but I am getting this error when I am hitting the API using AJAX request -

No 'Access-Control-Allow-Origin' header is present on the requested resource. Origin 'null' is therefore not allowed access.

The API returns correct data when requested using Chrome directly or using Postman.

One option is to use JSONP. I left a few pointers in your code here.

Tgr added a comment.Oct 6 2017, 7:10 PM

An interesting project with somewhat similar design considerations (but a completely different use case / target audience): Interaction timeline

Tgr updated the task description. (Show Details)Oct 6 2017, 10:04 PM
Meghasharma213 added a comment.EditedOct 7 2017, 12:32 PM

Hi @Tgr, thanks for the review.
I am done with task 1 as well. These are the required links: Tool, PR.
@Tgr @Slaporte, kindly review this as well.

Also, I've completed the eligibility section of the Outreachy application form. This is the link for my application.

Hi @Tgr, @Slaporte!
For microtask3, I have made a simple mock-up (PR) for the tool. I have explained the design here. The ideas are similar to the already existing features in Github and Stackoverflow.

Tgr updated the task description. (Show Details)Oct 8 2017, 12:14 AM
Tgr updated the task description. (Show Details)Oct 8 2017, 4:59 AM

@Tgr

Sir,
I have tried update my code as per your review instructions. Please review my PR1 and PR 2.

Tgr updated the task description. (Show Details)Oct 8 2017, 9:53 AM
katia added a subscriber: katia.Oct 9 2017, 3:43 PM

Hello @Tgr @Slaporte,
I’m Katia. I'm very new to tech, having started learning to code a year and a half ago. It's a lot of hard work, and I’m on my laptop more than anyone who values their sanity=) But I’m loving the experience and wouldn't dream of giving it up. Long term, I would love to become a software engineer. For the moment though, I'm keen to expand my skills. I’m joining this project to get better at coding. And I can’t wait to start learning new skills as well as designing and building things that could potentially make a dent in helping Wiki users. Excited to be here=)

This comment was removed by Meghasharma213.
Tgr updated the task description. (Show Details)Oct 10 2017, 3:50 AM
Tgr updated the task description. (Show Details)
Saayani updated the task description. (Show Details)Oct 10 2017, 5:54 AM
Saayani added a subscriber: Saayani.

@katia Hello and welcome! Glad to hear your interest in learning to code :) Remember, that you have less than two weeks before the Outreachy application deadline and you may not have enough time to go through all the application steps https://www.mediawiki.org/wiki/Outreachy/Participants#Application_process_steps. If you want to be ambitious and give it a shot, great! If not, and you are interested in contributing to Wikimedia projects, please see https://www.mediawiki.org/wiki/New_Developers.

Tgr updated the task description. (Show Details)Oct 13 2017, 7:32 AM
Saayani updated the task description. (Show Details)Oct 13 2017, 6:00 PM
Saayani updated the task description. (Show Details)Oct 13 2017, 7:45 PM
Tgr updated the task description. (Show Details)Oct 13 2017, 8:55 PM

Late Entry!

I  am Shreya ,Third Year Under graduate of SRM University,Chennai,India

Came to know about Outreachy couple of days back.Ill try to complete all microtasks given.

Skill:HTML ,CSS,JS , MySql ,C++ ,Java, Nodejs ,RubyonRails, R as well frameworks:Flask,Django

I have started working on microtask3 !

Can anyone tell me how to host Task using Toolforge?

Sir @Tgr I have worked on Task1 Code can you have look ?
I look forward to your comments and suggestions.
Thank you

Hi @Tgr @Slaporte ,

I've completed the task-2,
Link to Tool: Tool
Link to Code: PR

Kindly Review.

Thankyou

Can anyone tell me how to host Task using Toolforge?

Hi @Shreya1771 ,
Did you follow this ?
Where are you stuck?

Tgr updated the task description. (Show Details)Oct 15 2017, 2:10 AM
Tgr updated the task description. (Show Details)
Tgr updated the task description. (Show Details)Oct 15 2017, 7:30 AM
Tgr updated the task description. (Show Details)Oct 15 2017, 8:18 AM
Tgr added a comment.Oct 15 2017, 8:29 AM

Hi all!

If you are already working on a microtask/application: the deadline is October 23, and you have to finalize your application by then, and finish at least one microtask, but you can continue working on the other microtasks afterwards (probably for one week or so). Keep that in mind when prioritizing what to work on.

If you haven't started yet and are still in the process of looking for a project: this one is a bit crowded already. In the list of projects some have the comment "Needs More Applicants"; you'll probably have an easier time with those.

Tgr updated the task description. (Show Details)Oct 15 2017, 9:50 AM

@Tgr waiting for admin permission for project its still pending .Once its done Ill upload my tool. You can review my Code .
Working on Task2 now!
@Meghasharma213 Thank you

Tgr updated the task description. (Show Details)Oct 16 2017, 4:23 AM
Tgr updated the task description. (Show Details)Oct 16 2017, 4:27 AM

@Tgr @Slaporte

Sir,
I have completed Microtask 3 . Here is my PR .
I have also updated my tool and PR's for microtask1 and microtask2 .
Microtask 1 : tool, PR
Microtask 2 : tool, PR
Also, I've completed eligibilty details in outreachy application link.

@Tgr Sir,
I have created the wikimedia toolforge tool as required by the microtask-1, 2 given for the outreachy project(https://phabricator.wikimedia.org/T174528).
The source code is on github and I have mentioned you in the pull request that contains the source code of the tool (https://github.com/nikitiwari/tool_srish_wikimedia_toolforge/pull/1) .

Further I have also prepared the design mockup of this tool. Word file of the same is attached.
Please find the attachment.

Tgr updated the task description. (Show Details)Oct 18 2017, 7:35 AM
Tgr updated the task description. (Show Details)
Tgr updated the task description. (Show Details)Oct 18 2017, 7:40 AM
Tgr updated the task description. (Show Details)Oct 18 2017, 7:43 AM
Tgr updated the task description. (Show Details)Oct 18 2017, 7:47 AM

Hi @Tgr

I've updated the code for Task-2 based on your review.
Link to code: PR
Link to Tool: Tool

Kindly review.

Thanks.

Tgr updated the task description. (Show Details)Oct 18 2017, 8:17 PM
Tgr added a comment.Oct 19 2017, 10:38 AM

Hi all, reminder that you have to finish your application / project proposal, and publish the non-eligibility-related part of it as a Phabricator task, until the application deadline (Oct 23). See application step #9.

We'll mostly look at the Phabricator version of your proposals (the outreachy.org forms are a pain to read, have no rich text or change tracking) so make sure everything you consider important is present there. (Except for the eligibility-related information; that's only needed in the outreachy.org form.)

You can work on microtasks a little longer if you want (I'd guess until end of October but I don't know the exact date).

@Tgr I have updated Second task and Third task .
Please review .

Thank you!

Hi @Tgr @Slaporte ,

I've completed my project proposal.

Link to Proposal: Project Proposal

Kindly Review.

Also, Can you please look at the Code Changes I'd done based on your review for User Rank Tool?

Thanks :).

Tgr updated the task description. (Show Details)Oct 21 2017, 7:27 AM
Tgr updated the task description. (Show Details)Oct 23 2017, 3:42 AM
Tgr updated the task description. (Show Details)Oct 27 2017, 12:45 AM
Tgr updated the task description. (Show Details)Oct 27 2017, 3:39 AM
Tgr updated the task description. (Show Details)Oct 27 2017, 5:45 AM
Tgr updated the task description. (Show Details)Oct 27 2017, 5:58 AM
Tgr updated the task description. (Show Details)Oct 27 2017, 6:38 AM
Tgr updated the task description. (Show Details)
Tgr updated the task description. (Show Details)
Tgr updated the task description. (Show Details)Oct 28 2017, 7:06 PM

Hello @Tgr

I have made changes as you said. Also I have created tool : Microtask1 and Microtask2
Please review.

Thank you!

Tgr updated the task description. (Show Details)Oct 28 2017, 10:57 PM
Tgr updated the task description. (Show Details)Oct 28 2017, 11:58 PM
Tgr updated the task description. (Show Details)Oct 30 2017, 9:06 AM
Tgr moved this task from Next to Pending on the User-Tgr board.Oct 31 2017, 12:01 AM
Tgr added a comment.Nov 2 2017, 10:06 AM

Thanks all for contributing! The selection process has ended; the results will be published on Nov 9. If you would like to continue working on any open tasks, or contribute code in some other way, you are welcome to do so and I will provide code review if time permits, but it will not influence the selection.

Tgr updated the task description. (Show Details)Nov 11 2017, 8:02 PM
Tgr added a comment.Nov 11 2017, 8:07 PM

Archiving information related to the Outreachy application period into a comment.

Outreachy information

Skills needed: sitebuilding (HTML, CSS, JS), some backend language and website framework for generating the pages, SQL or API mashups (for getting the information - either from the MediaWiki API or from the Toolforge replica DB)
Mentors: @Tgr, @Slaporte
Microtasks (pick one - or suggest your own):

  • register a Toolforge account and create a simple tool (in the language of your choice; for the tool account please choose a name that starts with outreachy-) that takes a username and lists the recent English Wikipedia edits of that user. (See Toolforge Getting Started tutorial. You can either use the API or the database. Does not have to look nice.) Submit the code for review (this means a pull request or something equivalent). You can use the repository that comes with Toolforge (a bit clunky) or something like Github.
  • register a Toolforge account and create a simple tool (in the language of your choice; for the tool account please choose a name that starts with outreachy-) that takes a username and tells what percentile the user is at by number of edits. (ie. ranking all users by number of edits, is the user in the top 1%? top 5%?) You can find the data in the user table. Use a smallish wiki; calculating this for the English Wikipedia would take forever.
  • make a simple design mockup for the contribution timeline. (Could be HTML, an image or some open-source mockup tool... must be viewable without using closed-source software, though.)

Questions/problems with the microtasks: {Z614}

For general Outreachy information, see https://www.mediawiki.org/wiki/Outreachy/Round_15
For information on how to participate, see https://www.mediawiki.org/wiki/Outreachy/Participants

Applicants

Tgr added a comment.Nov 11 2017, 8:09 PM

Congrats @Meghasharma213 on being accepted and thanks everyone else for participating!

Tgr updated the task description. (Show Details)Nov 11 2017, 8:26 PM
Tgr mentioned this in WikiCV.Dec 4 2017, 5:33 AM

Is WikiCV something to be hosted on Toolforge? If so, it should be a subproject of https://phabricator.wikimedia.org/project/subprojects/703/ instead.

Tgr added a comment.Dec 11 2017, 1:44 AM

Indeed. (It would be nice to call that out on https://www.mediawiki.org/wiki/Phabricator/Creating_and_renaming_projects .)

I suppose I'll have to create a new project for that?

Meghasharma213 moved this task from Project to Review on the WikiCV board.Dec 23 2017, 5:22 PM
Meghasharma213 moved this task from Review to Project on the WikiCV board.
Tgr updated the task description. (Show Details)Apr 1 2018, 1:36 PM
Tgr updated the task description. (Show Details)Apr 1 2018, 1:39 PM
Tgr added a comment.Apr 1 2018, 1:57 PM

The Outreachy project has concluded; the tool is not fully functional yet (in hindsight my original estimate that everything from user research to implementation can be done as a student project in three month was not really realistic) but it's close, and can be finished as a volunteer effort. A presentation of the results is available. Thanks Megha!

@Tgr I'm guessing this task should not still live under Outreach-Programs-Projects? I am boldly removing the tag as we are cleaning up this workboard and planning on killing Possible-Tech-Projects.

Tgr moved this task from Pending to Backlog on the User-Tgr board.Feb 23 2019, 7:21 AM